unit TernarySeries;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, Vcl.ExtCtrls,
  VclTee.TeEngine, VclTee.TeeSurfa, VclTee.TeeTernary, Vcl.StdCtrls,
  VclTee.TeeProcs, VclTee.Chart, VclTee.TeeURL, VclTee.TeeSeriesTextEd, Data.DB,
  Data.Win.ADODB, VclTee.Series, VclTee.DBChart, kbmMemTable, kbmMemCSVStreamFormat, Vcl.Grids, Vcl.DBGrids;

type
  TTernarySeriesForm = class(TForm)
    Panel1: TPanel;
    kbmMemTable1: TkbmMemTable;
    DBChart1: TDBChart;
    Series1: TTernarySeries;
    kbmCSVStreamFormat1: TkbmCSVStreamFormat;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    Series2: TTernarySeries;
    Splitter1: TSplitter;
    procedure FormCreate(Sender: TObject);
    procedure kbmCSVStreamFormat1AfterLoad(Sender: TObject);
    procedure LoadFromMemTable;

  private
    { Private declarations }
    bSeries2: boolean;
    function SeriesGetPointerStyle(Sender: TChartSeries; ValueIndex: Integer): TSeriesPointerStyle;
    procedure SeriesAfterAdd(Sender: TChartSeries; ValueIndex: Integer);
  public
    { Public declarations }
  end;

var
  TernarySeriesForm: TTernarySeriesForm;
  kbmMemTable1: TkbmMemTable;

implementation

{$R *.dfm}

Uses EditChar, TeeConst, TeeTernaryEdit;

procedure TTernarySeriesForm.FormCreate(Sender: TObject);
var
  z: boolean;
  Lkbm: TkbmMemTable;
  af: TFieldDefs;
  i, j, n, t: Integer;
  LADO: TADOQuery;
  aDataset1, aDataset2, aDataset3: TDataset;
  s: string;

begin
  inherited;

  LoadFromMemTable;

end;

procedure  TTernarySeriesForm.LoadFromMemTable;

begin
  // Ian Added this to make db Chart work with Memtable
  kbmMemTable1.Active := True;
  kbmMemTable1.EmptyTable;
  kbmMemTable1.LoadFromFile('Na-Mg-K1.csv');

  with Series1 do
  begin
    VertexTitles[0][0] := 'Na/1000';
    VertexTitles[1][0] := 'Sqrt(Mg)';
    VertexTitles[2][0] := 'K/100';
    XValues.ValueSource := 'Na/1000';
    YValues.ValueSource := 'Sqrt(Mg)';
    ZValues.ValueSource := 'K/100';
    Pointer.Style := psDonut;
  end;

  with TPointSeries(DBChart1.AddSeries(TPointSeries)) do
  begin
    Title := DBChart1[0].Title;
    Pointer.Style := TTernarySeries(DBChart1[0]).Pointer.Style;
  end;

  DBChart1.RefreshDataSet(kbmMemTable1, Series1) ;

  kbmMemTable1.Active := True;
  kbmMemTable1.EmptyTable;
  kbmMemTable1.LoadFromFile('Na-Mg-K2.csv');

  with Series2 do
  begin
    VertexTitles[0][0] := 'Na/1000';
    VertexTitles[1][0] := 'Sqrt(Mg)';
    VertexTitles[2][0] := 'K/100';
    XValues.ValueSource := 'Na/1000';
    YValues.ValueSource := 'Sqrt(Mg)';
    ZValues.ValueSource := 'K/100';
    Pointer.Style := psTriangle;
  end;

  with TPointSeries(DBChart1.AddSeries(TPointSeries)) do
  begin
    Title := DBChart1[1].Title;
    Pointer.Style := TTernarySeries(DBChart1[1]).Pointer.Style;
  end;

  DBChart1.RefreshDataSet(kbmMemTable1, Series2) ;
end;


procedure TTernarySeriesForm.kbmCSVStreamFormat1AfterLoad(Sender: TObject);
begin
   //
end;

type
  TTernarySeriesAccess = class(TTernarySeries);

function TTernarySeriesForm.SeriesGetPointerStyle(Sender: TChartSeries; ValueIndex: Integer): TSeriesPointerStyle;
begin
  TTernarySeriesAccess(Sender).PreparePointer(ValueIndex);
  result := TTernarySeries(Sender).Pointer.Style;
end;

procedure TTernarySeriesForm.SeriesAfterAdd(Sender: TChartSeries; ValueIndex: Integer);
begin
  if (AnsiPos(Sender.Title, Sender.Labels[ValueIndex]) = 0) then
    Sender.Delete(ValueIndex);
end;

end.
